<%
'(P) 2003-05, C.K

'------------------------------------------------------------------------------
' Blogger 实体及相关操作类；包括用户注册，身份验证，分类/按月帖子列表等等
' 需要事先包含 CommonFunctions.asp 及 DataOperator，EnDec 类的定义
' -----------------------------------------------------------------------------

' Blogger 的基本信息（实体类）
Class BloggerInfo
	Private m_userId
	Private m_userName
	Private m_password
	Private m_email
	Private m_title
	Private m_intro
	Private m_blogNum
	Private m_friendPassword
	Private m_announcement
	Private m_skinName
	Private m_isPublic

	Private Sub Class_Initialize()
		m_userId = 0 'Guest 用户的 ID
		m_userName = ""
		m_password = ""
		m_email = ""
		m_title = ""
		m_intro = ""
		m_blogNum = 0
		m_friendPassword = ""
		m_announcement = ""
		m_skinName = "Default"
		m_isPublic = True
	End Sub

	'用户 ID
	Public Property Get UserID()
		UserID = m_userId
	End Property
	Public Property Let UserID(v_userId)
		m_userId = v_userId
	End Property

	'用户名 UserName
	Public Property Get UserName()
		UserName = m_userName
	End Property
	Public Property Let UserName(v_userName)
		m_userName = v_userName
	End Property

	'密码 Password
	Public Property Get Password()
		Password = m_password
	End Property
	Public Property Let Password(v_password)
		m_password = v_password
	End Property

	'电子邮件 EMail
	Public Property Get EMail()
		EMail = m_email
	End Property
	Public Property Let EMail(v_email)
		m_email = v_email
	End Property

	'Blog 标题 Title
	Public Property Get Title()
		Title = m_title
	End Property
	Public Property Let Title(v_title)
		m_title = v_title
	End Property

	'Blog 简介 Intro
	Public Property Get Intro()
		Intro = m_intro
	End Property
	Public Property Let Intro(v_intro)
		m_intro = v_intro
	End Property

	'网志数目
	Public Property Get BlogNum()
		BlogNum = m_blogNum
	End Property
	Public Property Let BlogNum(v_blogNum)
		m_blogNum = v_blogNum
	End Property

	'Blog 好友密码 FriendPassword
	Public Property Get FriendPassword()
		FriendPassword = m_friendPassword
	End Property
	Public Property Let FriendPassword(v_friendPassword)
		m_friendPassword = v_friendPassword
	End Property

	'Blog 公告 Announcement
	Public Property Get Announcement()
		Announcement = m_announcement
	End Property
	Public Property Let Announcement(v_announcement)
		m_announcement = v_announcement
	End Property

	'Blog 皮肤 SkinName
	Public Property Get SkinName()
		SkinName = m_skinName
	End Property
	Public Property Let SkinName(v_skinName)
		m_skinName = v_skinName
	End Property

	'Blog 是否允许任何人直接发表评论？IsPublic
	Public Property Get IsPublic()
		IsPublic = m_isPublic
	End Property
	Public Property Let IsPublic(v_isPublic)
		m_isPublic = v_isPublic
	End Property
End Class

' Blogger 操作类
Class BloggersDB
	Private m_connString
	Private m_currentBloggerInfo
	Private m_dataOperator

	Private Sub Class_Initialize()
		m_connString = ""
		Set m_currentBloggerInfo = New BloggerInfo
		Set m_dataOperator = New DataOperator
	End Sub

	Private Sub Class_Terminate()
		Set m_dataOperator = Nothing
		Set m_currentBloggerInfo = Nothing
	End Sub

	'设置数据源连接字符串，打开数据源连接
	Public Property Let DataConnectionString(connStr)
		m_connString = connStr
		m_dataOperator.OpenDatabase connStr
	End Property

	'根据当前 context 的 Session/Cookies 获取 BloggerInfo 对象，是一个工具方法，不是很适合放在这个类里边 @_@
	Public Property Get CurrentBloggerInfo()
		Dim uid
		uid = CF_GetSession("BloggerID") '先从 Session 中获取……
		If "" = uid Then
			uid = CF_GetCookie("BloggerID") 'Session 读取失败，再从 Cookie 中取
			If uid <> "" Then
				Dim oEnDec, encPwd, decPwd, oriPwd
				oriPwd = m_dataOperator.ExecuteArray("SELECT [Password] FROM T_Bloggers WHERE [UID] = @userId", Array(CLng(uid)))

				If Not IsNull(oriPwd) Then '这个判断其实意义不大 @_@
					encPwd = CF_GetCookie("Password") '从 Cookie 中获取密码（加密过的）
					Set oEnDec = New EnDec
					oEnDec.Dec encPwd
					decPwd = oEnDec.ShowCode(False) '获得解密后的密码
					Set oEnDec = Nothing

					If StrComp(CStr(oriPwd(0, 0)), decPwd) = 0 Then '校验密码（正确）……
						Set m_currentBloggerInfo = GetBloggerInfo(CLng(uid)) '返回当前登录用户的信息
						CF_SetSession "BloggerID", uid '重建 Session
					End If
				End If
			End If
		Else '有 Session 记录
			Set m_currentBloggerInfo = GetBloggerInfo(CLng(uid))
		End If
		Set CurrentBloggerInfo = m_currentBloggerInfo
	End Property

	'由 userId 获取 BloggerInfo 对象
	Public Function GetBloggerInfo(userId)
		Dim arrBloggerInfo
		arrBloggerInfo = m_dataOperator.ExecuteArray("SELECT [UID], [UserName], [Password], [EMail], [Title], [Intro], [BlogNum], [FriendPassword], [Announcement], [SkinName], [IsPublic]  FROM T_Bloggers WHERE [UID] = @userId", Array(userId))
		If IsArray(arrBloggerInfo) Then
			m_currentBloggerInfo.UserID = arrBloggerInfo(0, 0)
			m_currentBloggerInfo.UserName = arrBloggerInfo(1, 0)
			m_currentBloggerInfo.Password = arrBloggerInfo(2, 0)
			m_currentBloggerInfo.EMail = arrBloggerInfo(3, 0)
			m_currentBloggerInfo.Title = arrBloggerInfo(4, 0)
			m_currentBloggerInfo.Intro = arrBloggerInfo(5, 0)
			m_currentBloggerInfo.BlogNum = arrBloggerInfo(6, 0)
			m_currentBloggerInfo.FriendPassword = arrBloggerInfo(7, 0)
			m_currentBloggerInfo.Announcement = arrBloggerInfo(8, 0)
			m_currentBloggerInfo.SkinName = arrBloggerInfo(9, 0)
			m_currentBloggerInfo.IsPublic = arrBloggerInfo(10, 0)
		Else
			Err.Raise vbObjectError + 1000, "nirvana: BloggersDB", "Specified Blogger does not exist!"
		End If
		Set GetBloggerInfo = m_currentBloggerInfo
	End Function

	'注册新 Blogger，返回新用户的 UID
	Public Function RegisterBlogger(newBlogger, regIP)
		Dim userName, password, email, title, intro
		userName = newBlogger.UserName
		password = newBlogger.Password
		email = newBlogger.EMail
		title = newBlogger.Title
		intro = newBlogger.Intro
		Dim dupName, retval
		dupName = m_dataOperator.ExecuteArray("SELECT [UID] FROM T_Bloggers WHERE [UserName] = @userName", Array(userName))
		If Not IsNull(dupName) Then '该 UserName 已经被注册！
			retval = "[REG_DUPNAME]"
		Else '为获取新 ID，写入临时 GUID，避免并发冲突
			Dim oTyp : Set oTyp = Server.CreateObject("Scriptlet.TypeLib")
			Dim guid : guid = CStr(oTyp.GUID)
			Set oTyp = Nothing
			m_dataOperator.ExecuteNonQuery "INSERT INTO T_Bloggers ([UserName], [Password], [EMail], [RegIP], [Title], [Intro], [RegTempID]) VALUES (@userName, @password, @email, @regIP, @title, @intro, @regTempId)", Array(userName, password, email, regIP, title, intro, guid)
			Dim newBloggerID
			newBloggerID = m_dataOperator.ExecuteArray("SELECT [UID] FROM T_Bloggers WHERE [RegTempID] = @regTempId", Array(guid))
			retval = CLng(newBloggerID(0, 0))
		End If
		RegisterBlogger = retval
	End Function

	'更新 Blogger 注册信息
	Public Sub UpdateBloggerInfo(bloggerInfo)
		Dim userId, password, email, title, intro, friendPwd, announcement, skinName, isPublic
		userId = bloggerInfo.UserID : password = bloggerInfo.Password : email = bloggerInfo.EMail
		title = bloggerInfo.Title : intro = bloggerInfo.Intro : friendPwd = bloggerInfo.FriendPassword
		announcement = bloggerInfo.Announcement : skinName = bloggerInfo.SkinName : isPublic = bloggerInfo.IsPublic

		m_dataOperator.ExecuteNonQuery "UPDATE T_Bloggers SET [Password] = @password, [EMail] = @email, [Title] = @title, [Intro] = @intro, [FriendPassword] = @friendPassword, [Announcement] = @announcement, [SkinName] = @skinName, [IsPublic] = @isPublic WHERE [UID] = @userId", Array(password, email, title, intro, friendPwd, announcement, skinName, isPublic, userId)
		'清除相关缓存
	End Sub

	'Blogger 登录
	Public Function Login(userName, password, rememberPwd)
		Dim loginCheck, retval
		loginCheck = m_dataOperator.ExecuteArray("SELECT [UID], [UserName], [Password] FROM T_Bloggers WHERE [UserName] = @userName", Array(userName))
		If Not IsNull(loginCheck) Then '用户存在
			Dim actualPwd
			actualPwd = CStr(loginCheck(2, 0))
			If StrComp(password, actualPwd) = 0 Then '密码正确
				'加密密码
				Dim oEnc
				Set oEnc = New EnDec
				oEnc.Enc actualPwd

				'设置 Cookies
				CF_SetCookie "BloggerID", CStr(loginCheck(0, 0))
				CF_SetCookie "UserName", CStr(loginCheck(1, 0))
				CF_SetCookie "Password", oEnc.ShowCode(True) '写入加密后的密码
				If rememberPwd Then '选择了保存 Cookie
					CF_SetCookieExpirationDate 90 '存 90 天
				End If
				Set oEnc = Nothing

				CF_SetSession "BloggerID", loginCheck(0, 0) '用户已经登录的唯一凭据（还是觉得 Session 好……）
				retval = loginCheck(0, 0) '成功登录的话，返回 BloggerID
			Else '密码错误
				retval = "[LOGIN_PWDERROR]"
			End If
		Else '用户不存在
			retval = "[LOGIN_NOUSER]"
		End If
		Login = retval
	End Function

	'Blog 好友登录
	Public Function FriendLogin(bloggerId, friendPwd)
		Dim chk, retval
		chk = m_dataOperator.ExecuteArray("SELECT [FriendPassword] FROM T_Bloggers WHERE [UID] = @userId", Array(bloggerId))
		If Not IsNull(chk) Then
			If StrComp(CStr(chk(0, 0)), friendPwd) = 0 Then '好友密码正确
				Dim oEnc
				Set oEnc = New EnDec
				oEnc.Enc friendPwd

				CF_SetCookie "CanViewSecretPosts_" & CStr(bloggerId), oEnc.ShowCode(True) '写入加密后的密码
				CF_SetCookieExpirationDate 7 '存 7 天
				Set oEnc = Nothing

				CF_SetSession "CanViewSecretPosts_" & CStr(bloggerId), "yEs"
				retval = "[LOGIN_OK]"
			Else '密码错误
				retval = "[LOGIN_PWDERROR]"
			End If
		Else
			retval = "[LOGIN_NOUSER]"
		End If
		FriendLogin = retval
	End Function

	'列出全部可见的 Blogger
	Public Function ListBloggers()
		Dim retval
		retVal = m_dataOperator.ExecuteArray("SELECT [UID], [UserName], [Title], [BlogNum], (SELECT SUM([CommentNum]) FROM T_Blogs WHERE [BelongTo] = [UID] AND [State] < 2) AS CommentNum, [LastUpdateTime], [Intro] FROM T_Bloggers WHERE [Show] = True ORDER BY [LastUpdateTime] DESC, [BlogNum] DESC, [RegDate]", Null) '列出 Show = True 的
		ListBloggers = retVal
	End Function

	'获得自定义网志分类列表
	Public Function GetBlogCustomCategoryList(bloggerId)
		Dim retval
		retval = m_dataOperator.ExecuteArray("SELECT [CateID], [CateName], [BelongTo], [Description] FROM T_Categories WHERE [BelongTo] = @belongTo AND [CateID] <> 1 ORDER BY [CateName]", Array(bloggerId))
		GetBlogCustomCategoryList = retval
	End Function

	'获得网志月档案列表（不列出草稿）
	Public Function GetBlogArchivesList(bloggerId)
		Dim retval
		retval = m_dataOperator.ExecuteArray("SELECT FIRST(DATEPART('yyyy', [PostTime])) AS [Year], FIRST(DATEPART('m', [PostTime])) AS [Month], COUNT([BID]) AS [Num], FIRST([BelongTo]) FROM T_Blogs WHERE [BelongTo] = @belongTo AND [State] < 2 GROUP BY DATEPART('yyyy', [PostTime]), DATEPART('m', [PostTime]) ORDER BY FIRST(DATEPART('yyyy', [PostTime])) DESC, FIRST(DATEPART('m', [PostTime])) DESC", Array(bloggerId))
		GetBlogArchivesList = retval
	End Function
	Public Function GetBlogArchivesListA(bloggerId) '后台用，包括选出草稿
		Dim retval
		retval = m_dataOperator.ExecuteArray("SELECT FIRST(DATEPART('yyyy', [PostTime])) AS [Year], FIRST(DATEPART('m', [PostTime])) AS [Month], COUNT([BID]) AS [Num], FIRST([BelongTo]) FROM T_Blogs WHERE [BelongTo] = @belongTo GROUP BY DATEPART('yyyy', [PostTime]), DATEPART('m', [PostTime]) ORDER BY FIRST(DATEPART('yyyy', [PostTime])) DESC, FIRST(DATEPART('m', [PostTime])) DESC", Array(bloggerId))
		GetBlogArchivesListA = retval
	End Function

	'获得友情链结列表
	Public Function GetLinks(bloggerId)
		Dim retval
		retval = m_dataOperator.ExecuteArray("SELECT [LID], [LinkTitle], [LinkAddress], [BelongTo], [Description] FROM T_Links WHERE [BelongTo] = ? ORDER BY [LinkTitle]", Array(bloggerId))
		GetLinks = retval
	End Function

	'获得近期评论列表（显示在首页，通过了认证的）
	Public Function GetRecentComments(bloggerId, num)
		Dim retval
		retval = m_dataOperator.ExecuteArray("SELECT TOP " & CStr(num) & " C.CID, C.CommentTo, C.Content, C.AuthorName, B.State FROM T_Comments C LEFT JOIN T_Blogs B ON C.CommentTo = B.BID WHERE C.State = 1 AND B.BelongTo = @belongTo AND B.State < 2 ORDER BY C.CID DESC", Array(bloggerId))
		GetRecentComments = retval
	End Function

	'获取评论数目（经过认证的）
	Public Function GetCommentNum(bloggerId)
		Dim re
		re = m_dataOperator.ExecuteArray("SELECT SUM(CommentNum) FROM T_Blogs WHERE [BelongTo] = @belongTo AND [State] < 2", Array(bloggerId))
		If IsNull(re(0, 0)) Then
			GetCommentNum = "0"
		Else
			GetCommentNum = re(0, 0)
		End If
	End Function

	'获取最新的几条 blog 文章，显示在首页
	'UPD@050605: 多选取一个字段以便前台显示编辑链结
	Public Function GetTopEntries(bloggerId, num)
		Dim retval
		retval = m_dataOperator.ExecuteArray("SELECT TOP " & CStr(num) & " [BID], [BelongTo], [PostTime], [PostTime] AS PostTime1, [Title], [Expression], [Content], [CommentNum], [State], [CategoryName], 'EditLink', [Tags] FROM T_Blogs WHERE [BelongTo] = @belongTo AND [State] < 2 ORDER BY [PostTime] DESC, [BID] DESC", Array(bloggerId))
		GetTopEntries = retval
	End Function

	'判断当前 context 是否是 Blog 好友
	Public Function CanViewSecretPosts(bloggerId, friendPwd)
		Dim retval
		retval = False

		Dim friendPassword '从客户端 cookie 取得的加密后的好友密码
		friendPassword = CF_GetSession("CanViewSecretPosts_" & CStr(bloggerId))
		If StrComp(friendPassword, "yEs") <> 0 Then
			friendPassword = CF_GetCookie("CanViewSecretPosts_" & CStr(bloggerId))
			If "" <> friendPassword Then
				Dim oEnDec, encp, decp
				encp = friendPassword

				Set oEnDec = New EnDec
				oEnDec.Dec encp
				decp = oEnDec.ShowCode(False) '获得解密后的密码
				Set oEnDec = Nothing

				If StrComp(friendPwd, decp) = 0 Then '校验密码（正确）……
					retval = True
					CF_SetSession "CanViewSecretPosts_" & CStr(bloggerId), "yEs" '重建 Session
				End If
			End If
		Else
			retval = True
		End If

		CanViewSecretPosts = retval
	End Function

	'获取某自定义分类下的网志列表
	'UPD@050605: 正文选取 101 个字|多选取一个字段以便前台显示编辑链结
	Public Function GetBlogListByCategory(bloggerId, cateId)
		Dim retval
		retval = m_dataOperator.ExecuteArray("SELECT [BID], [PostTime], [Title], [Expression], LEFT([Content], 101) AS Content1, [State], [BelongTo], 'EditLink', [Tags] FROM T_Blogs WHERE [CategoryID] = @categoryId AND [BelongTo] = @belongTo AND [State] < 2 ORDER BY [PostTime] DESC, [BID] DESC", Array(cateId, bloggerId))
		GetBlogListByCategory = retval
	End Function

	'为分类 RSS 源设立
	Public Function GetBlogListByCategory4Feed(bloggerId, cateId, num)
		Dim retval
		retval = m_dataOperator.ExecuteArray("SELECT TOP " & CStr(num) & " [BID], [BelongTo], [PostTime], [PostTime] AS PostTime1, [Title], [Expression], [Content], [CommentNum], [State], [CategoryName] FROM T_Blogs WHERE [CategoryID] = @categoryId AND [BelongTo] = @belongTo AND [State] < 2 ORDER BY [PostTime] DESC, [BID] DESC", Array(cateId, bloggerId))
		GetBlogListByCategory4Feed = retval
	End Function

	'根据分类 ID 获得分类的名称
	Public Function GetBlogCategoryNameDescByID(cateId, bloggerId)
		Dim re
		re = m_dataOperator.ExecuteArray("SELECT [CateName], [Description] FROM T_Categories WHERE [CateID] = @cateId AND [BelongTo] = @belongTo AND [CateID] <> 1", Array(cateId, bloggerId))
		If Not IsNull(re) Then
			GetBlogCategoryNameDescByID = re
		Else
			GetBlogCategoryNameDescByID = Null
		End If
	End Function

	'获取某月的网志列表
	'UPD@050605: 正文选取 101 个字|多选取一个字段以便前台显示编辑链结
	Public Function GetBlogListByMonth(bloggerId, mYear, mMonth)
		Dim retval
		retval = m_dataOperator.ExecuteArray("SELECT [BID], [PostTime], [Title], [Expression], LEFT([Content], 101) AS Content1, [State], [BelongTo], [CategoryID], [CategoryName], 'EditLink', [Tags] FROM T_Blogs WHERE DATEPART('yyyy', PostTime) = @year AND DATEPART('m', PostTime) = @month AND [BelongTo] = @belongTo AND [State] < 2 ORDER BY [PostTime] DESC, [BID] DESC", Array(mYear, mMonth, bloggerId))
		GetBlogListByMonth = retval
	End Function
	Public Function GetBlogListByMonthA(bloggerId, mYear, mMonth) '后台管理版本（草稿帖也选出）
		Dim retval
		retval = m_dataOperator.ExecuteArray("SELECT [BID], [PostTime], [Title], [Expression], LEFT([Content], 101) AS Content1, [State], [BelongTo], [CategoryID], [CategoryName], [Tags] FROM T_Blogs WHERE DATEPART('yyyy', PostTime) = @year AND DATEPART('m', PostTime) = @month AND [BelongTo] = @belongTo ORDER BY [PostTime] DESC, [BID] DESC", Array(mYear, mMonth, bloggerId))
		GetBlogListByMonthA = retval
	End Function
	Public Function GetBlogListByMonthAEx(bloggerId, mYear, mMonth) '导出版本（选出全部正文，不要草稿帖）
		Dim retval
		retval = m_dataOperator.ExecuteArray("SELECT [BID], [PostTime], [Title], [Expression], [Content], [State], [BelongTo], [CategoryID], [CategoryName] FROM T_Blogs WHERE DATEPART('yyyy', PostTime) = @year AND DATEPART('m', PostTime) = @month AND [BelongTo] = @belongTo AND [State] < 2 ORDER BY [PostTime] DESC, [BID] DESC", Array(mYear, mMonth, bloggerId))
		GetBlogListByMonthAEx = retval
	End Function

	'获得未经认证的评论列表
	Public Function GetUnauthorizedComments(bloggerId)
		Dim retval
		retval = m_dataOperator.ExecuteArray("SELECT C.CID, C.CommentTo, C.Content, C.AuthorName, C.EMail, C.Link, C.PostTime, C.FromIP, B.Title FROM T_Comments C LEFT JOIN T_Blogs B ON C.CommentTo = B.BID WHERE C.State = 0 AND B.BelongTo = @belongTo ORDER BY C.CID DESC", Array(bloggerId))
		GetUnauthorizedComments = retval
	End Function
	'获得近期评论列表（后台用，显示更多信息）
	Public Function GetRecentComments4Mgmt(bloggerId, num)
		Dim retval
		retval = m_dataOperator.ExecuteArray("SELECT TOP " & CStr(num) & " C.CID, C.CommentTo, C.Content, C.AuthorName, C.EMail, C.Link, C.PostTime, C.FromIP, B.Title FROM T_Comments C LEFT JOIN T_Blogs B ON C.CommentTo = B.BID WHERE C.State = 1 AND B.BelongTo = @belongTo AND B.State < 2 ORDER BY C.CID DESC", Array(bloggerId))
		GetRecentComments4Mgmt = retval
	End Function

	'验证通过评论
	'需要修改 T_Blogs 表的 CommentNum 列
	Public Sub AuthorizeComments(commentIds)
		Dim cIds, c
		cIds = Split(commentIds, ", ") '经过验证，分割符确实是“, ”！
		For c = 0 To UBound(cIds)
			m_dataOperator.ExecuteNonQuery "UPDATE T_Blogs SET [CommentNum] = [CommentNum] + 1 WHERE [BID] = (SELECT [CommentTo] FROM T_Comments WHERE [CID] = @commentId)", Array(cIds(c))
		Next
		m_dataOperator.ExecuteNonQuery "UPDATE T_Comments SET [State] = 1 WHERE [CID] IN (" & commentIds & ")", Null '状态设置为 1
		'清除有关缓存
	End Sub

	'批量删除评论（后台评论管理）（目前都是未经验证的评论，添加它们时并未更新评论计数，故直接删除即可！）
	'需要修改 T_Blogs 表的 CommentNum 列
	Public Sub BatchDeleteComments(commentIds)
		m_dataOperator.ExecuteNonQuery "DELETE FROM T_Comments WHERE [CID] IN (" & commentIds & ")", Null
		'清除有关缓存
	End Sub

	'获取最新发表的 num 条 blog
	Public Function GetLatestEntries(num)
		Dim retval
		retval = m_dataOperator.ExecuteArray("SELECT TOP " & CStr(num) & " B.[BID], B.[BelongTo], B.[PostTime], B.[Title], B.[AuthorName], B.[Expression], B.[Content], B.[Tags], B.[CommentNum] FROM T_Blogs B LEFT JOIN T_Bloggers L ON B.BelongTo = L.UID WHERE B.[State] = 1 AND L.[Show] = True ORDER BY B.[PostTime] DESC, B.[BID] DESC", Null)
		GetLatestEntries = retval
	End Function

	'社区首页用，最新帖的 RSS
	Public Function GetLatestEntries4RSS(num)
		Dim retval
		retval = m_dataOperator.ExecuteArray("SELECT TOP " & CStr(num) & " B.[BID], B.[BelongTo], B.[PostTime], B.[AuthorName], B.[Title], B.[Expression], B.[Content], B.[CommentNum], B.[State], B.[CategoryName] FROM T_Blogs B LEFT JOIN T_Bloggers L ON B.BelongTo = L.UID WHERE B.[State] = 1 AND L.[Show] = True ORDER BY B.[PostTime] DESC, B.[BID] DESC", Null)
		GetLatestEntries4RSS = retval
	End Function
End Class
%>
