﻿<%
'(P) 2003-05, C.K

'------------------------------------------------------------------------------
'Blog 帖子分类相关类
'需要事先包含 CommonFunctions.asp 和 DataOperator 类的定义
'------------------------------------------------------------------------------

'结构太简单，就不要实体类了吧
Class CategoriesDB
	Private m_connString
	Private m_dataOperator
	Private m_currentBloggerId

	Private Sub Class_Initialize()
		m_currentBloggerId = 0
		Set m_dataOperator = New DataOperator
	End Sub

	Private Sub Class_Terminate()
		Set m_dataOperator = Nothing
	End Sub

	Public Property Let DataConnectionString(connStr)
		m_connString = connStr
		m_dataOperator.OpenDatabase connStr
	End Property

	Public Property Let CurrentBloggerID(bloggerId)
		m_currentBloggerId = bloggerId
	End Property

	Public Sub AddCategory(cateName, cateDesc)
		m_dataOperator.ExecuteNonQuery "INSERT INTO T_Categories ([CateName], [Description], [BelongTo]) VALUES (@cateName, @cateDesc, @belongTo)", Array(cateName, cateDesc, m_currentBloggerId)
		'清除有关缓存
	End Sub

	'Updated@060801: 方法名改变；增加“类别描述”字段
	Public Sub ModifyCategory(cateId, newCateName, newCateDesc)
		m_dataOperator.ExecuteNonQuery "UPDATE T_Categories SET [CateName] = @cateName, [Description] = @cateDesc WHERE [BelongTo] = @belongTo AND [CateID] = @cateId", Array(newCateName, newCateDesc, m_currentBloggerId, cateId)
		m_dataOperator.ExecuteNonQuery "UPDATE T_Blogs SET [CategoryName] = @cateName WHERE [BelongTo] = @belongTo AND [CategoryID] = @cateId", Array(newCateName, m_currentBloggerId, cateId) '更新文章对应的“分类名”字段
		'清除有关缓存
	End Sub

	Public Sub DeleteCategory(cateId)
		m_dataOperator.ExecuteNonQuery "DELETE FROM T_Categories WHERE [BelongTo] = @belongTo AND [CateID] = @cateId", Array(m_currentBloggerId, cateId)
		m_dataOperator.ExecuteNonQuery "UPDATE T_Blogs SET [CategoryID] = @newCateId, [CategoryName] = @cateName WHERE [BelongTo] = @belongTo AND [CategoryID] = @cateId", Array(1, "未分类", m_currentBloggerId, cateId) '原本属于该分类的文章归为“未分类”
		'清除有关缓存
	End Sub

	Public Function GetCategoryName(cateId)
		Dim retval
		retval = m_dataOperator.ExecuteArray("SELECT [CateName] FROM T_Categories WHERE [BelongTo] = @belongTo AND [CateID] = @cateId", Array(m_currentBloggerId, cateId))
		GetCategoryName = CStr(retval(0, 0)) '错误判断？
	End Function
	
	Public Function GetCategoryDescription(cateId)
		Dim retval
		retval = m_dataOperator.ExecuteArray("SELECT [Description] FROM T_Categories WHERE [BelongTo] = @belongTo AND [CateID] = @cateId", Array(m_currentBloggerId, cateId))
		GetCategoryDescription = CStr(retval(0, 0)) '错误判断？
	End Function
End Class
%>
