﻿<%
'(P) 2003-05, C.K

'模版操作类

Class PageBuilder
	Private m_regExpProc
	Private m_dicSlots, m_dicRepeaters
	Private m_fsoLoader
	Private m_skinPath
	Private m_pageContent
	Private m_isSkinLoaded
	Private m_debugInfo

	Private Sub Class_Initialize()
		Set m_regExpProc = New RegExp
		m_regExpProc.IgnoreCase = False
		m_regExpProc.Global = True

		Set m_dicSlots = Server.CreateObject("Scripting.Dictionary")
		Set m_dicRepeaters = Server.CreateObject("Scripting.Dictionary")
		Set m_fsoLoader = Server.CreateObject("Scripting.FileSystemObject")
		m_isSkinLoaded = False
	End Sub

	Private Sub Class_Terminate()
		Set m_regExpProc = Nothing
		Set m_fsoLoader = Nothing
		m_dicSlots.RemoveAll : Set m_dicSlots = Nothing
		m_dicRepeaters.RemoveAll : Set m_dicRepeaters = Nothing
	End Sub

	Private Function LoadFromTemplateFile(filePath)
		Dim objStream, fileContent
		Set objStream = Server.CreateObject("ADODB.Stream")
		With objStream
			.Type = 2
			.Mode = 3
			.Open
			.LoadFromFile filePath
			.Charset = "utf-8"
			.Position = 2
			fileContent = .ReadText
			.Close
		End With
		Set objStream = Nothing
		LoadFromTemplateFile = fileContent
	End Function

	Public Property Let TemplateFile(skinFilePath)
		m_skinPath = skinFilePath
		If m_fsoLoader.FileExists(m_skinPath) Then
'			Dim f : Set f = m_fsoLoader.OpenTextFile(m_skinPath, 1, False, -2) '以系统默认编码打开
'			m_pageContent = f.ReadAll()
'			f.Close : Set f = Nothing
			m_pageContent = LoadFromTemplateFile(m_skinPath)
			m_isSkinLoaded = True
			Call ProcessRepeaters() '预先获取 Repeater 区块的信息...
		Else
			Err.Raise vbObjectError + 1000, "nirvana: PageBuilder", "Specified page template file does not exist!"
		End If
	End Property

	Public Property Let Slot(slotName, slotValue)
		If m_dicSlots.Exists(slotName) Then
			m_dicSlots.Item(slotName) = slotValue
		Else
			m_dicSlots.Add slotName, slotValue
		End If
	End Property

	Public Property Get Slot(slotName)
		If m_dicSlots.Exists(slotName) Then
			Slot = m_dicSlots.Item(slotName)
		Else
			Slot = ""
		End If
	End Property

	Public Sub UpdateSlots()
		If m_isSkinLoaded Then
			Dim slot
			For Each slot In m_dicSlots.Keys
				m_regExpProc.Pattern = "{{" & slot & "}}"
				m_pageContent = m_regExpProc.Replace(m_pageContent, m_dicSlots.Item(slot))
			Next
		Else
			Err.Raise vbObjectError + 1000, "nirvana: PageBuilder", "Page template has not been loaded!"
		End If
	End Sub

	Private Sub ProcessRepeaters()
		'Repeater 区块的结构：
		'<!--n_Repeater=repeaterId-->
		'...
		'<!--/n_Repeater=repeaterId-->
		m_regExpProc.Pattern = "<!" & "--n_Repeater=(\w+)-->((\r\n|.)*?)" & "<!" & "--\/n_Repeater=\1-->" '会不会很慢呢？
		Dim matches, match : Set matches = m_regExpProc.Execute(m_pageContent)
		Dim rptId, rptTemplate
		For Each match In matches
			rptId = match.SubMatches(0) : rptTemplate = match.SubMatches(1)
			If Not m_dicRepeaters.Exists(rptId) Then
				m_dicRepeaters.Add rptId, rptTemplate
			Else
				m_dicRepeaters.Item(rptId) = rptTemplate
			End If
		Next
		Set matches = Nothing
	End Sub

	Public Property Let RepeaterDataSource(repeaterId, dataArray)
		If Not m_dicRepeaters.Exists(repeaterId) Then
			Err.Raise vbObjectError + 1000, "nirvana: PageBuilder", "Specified Repeater Block does not exist!"
		Else
			Dim repText, repRowTemplate, repRow
			repText = "" : repRow = "" : repRowTemplate = m_dicRepeaters.Item(repeaterId)
			If Not IsNull(dataArray) Then
				Dim row
				For row = 0 To UBound(dataArray, 2)
					repRow = ReplaceRepeaterRow(repRowTemplate, dataArray, row)
					repText = repText & repRow
				Next
			End If

			m_regExpProc.Pattern = "<!" & "--n_Repeater=" & repeaterId & "-->(\r\n|.)*?" & "<!" & "--\/n_Repeater=" & repeaterId & "-->"
			m_pageContent = m_regExpProc.Replace(m_pageContent, repText)
		End If
	End Property

	Private Function ReplaceRepeaterRow(src, arrData, cr)
		Dim i, retval
		retval = src
		For i = 0 To UBound(arrData, 1)
			retval = Replace(retval, "{" & CStr(i) & "}", arrData(i, cr))
		Next
		ReplaceRepeaterRow = retval
	End Function

	Public Function FinalOutput()
		FinalOutput = m_pageContent
	End Function
End Class
%>
