﻿<%
'(P) 2003-05, C.K

'------------------------------------------------------------------------------
'Blog 悄悄话相关类
'需要事先包含 CommonFunctions.asp 和 DataOperator 类的定义
'------------------------------------------------------------------------------

'一条悄悄话信息
Class PrivateMessage
	Private m_pmId
	Private m_fromName
	Private m_toUser
	Private m_title
	Private m_content
	Private m_sendTime
	Private m_senderEMail
	Private m_fromIP

	Public Property Get PMID()
		PMID = m_pmId
	End Property
	Public Property Let PMID(v_pmId)
		m_pmId = v_pmId
	End Property

	Public Property Get FromName()
		FromName = m_fromName
	End Property
	Public Property Let FromName(v_fromName)
		m_fromName = v_fromName
	End Property

	Public Property Get ToUser()
		ToUser = m_toUser
	End Property
	Public Property Let ToUser(v_toUser)
		m_toUser = v_toUser
	End Property

	Public Property Get Title()
		Title = m_title
	End Property
	Public Property Let Title(v_title)
		m_title = v_title
	End property

	Public Property Get Content()
		Content = m_content
	End Property
	Public Property Let Content(v_content)
		m_content = v_content
	End Property

	Public Property Get SendTime()
		SendTime = m_sendTime
	End property
	Public Property Let SendTime(v_sendTime)
		m_sendTime = v_sendTime
	End Property

	Public Property Get SenderEMail()
		SenderEMail = m_senderEMail
	End property
	Public Property Let SenderEMail(v_senderEMail)
		m_senderEMail = v_senderEMail
	End Property

	Public Property Get FromIP()
		FromIP = m_fromIP
	End Property
	Public Property Let FromIP(v_fromIP)
		m_fromIP = v_fromIP
	End Property
End Class

'悄悄话操作类
Class PrivateMessagesDB
	Private m_connString
	Private m_dataOperator
	Private m_currentBloggerId
	Private m_currentPM

	Private Sub Class_Initialize()
		m_currentBloggerId = 0
		Set m_currentPM = New PrivateMessage
		Set m_dataOperator = New DataOperator
	End Sub

	Private Sub Class_Terminate()
		Set m_dataOperator = Nothing
		Set m_currentPM = Nothing
	End Sub

	Public Property Let DataConnectionString(connStr)
		m_connString = connStr
		m_dataOperator.OpenDatabase connStr
	End Property

	Public Property Let CurrentBloggerID(bloggerId)
		m_currentBloggerId = bloggerId
	End Property

	'UPD@050605: 参数改为实体类
	Public Sub SendPrivateMessage(pmsg)
		Dim fromName, title, content, senderEMail, fromIP
		fromName = pmsg.FromName : title = pmsg.Title : content = pmsg.Content
		senderEMail = pmsg.SenderEMail : fromIP = pmsg.FromIP

		m_dataOperator.ExecuteNonQuery "INSERT INTO T_PMs ([FromName], [ToUser], [Title], [Content], [SenderEMail], [FromIP]) VALUES (@fromName, @toUser, @title, @content, @senderEMail, @fromIP)", Array(fromName, m_currentBloggerId, title, content, senderEmail, fromIP)
	End Sub

	Public Sub DeletePMs(pmIds) '批量删除悄悄话
		m_dataOperator.ExecuteNonQuery "DELETE FROM T_PMs WHERE [PMID] IN (" & pmIds & ")", Null
	End Sub

	Public Function GetPrivateMessages()
		Dim retval
		retval = m_dataOperator.ExecuteArray("SELECT * FROM T_PMs WHERE [ToUser] = @userId ORDER BY [PMID] DESC", Array(m_currentBloggerId))
		GetPrivateMessages = retval
	End Function

	Public Function GetPMCount()
		Dim totalNum, newNum
		totalNum = m_dataOperator.ExecuteArray("SELECT COUNT(PMID) FROM T_PMs WHERE [ToUser] = @userId", Array(m_currentBloggerId))
		newNum = m_dataOperator.ExecuteArray("SELECT COUNT(PMID) FROM T_PMs WHERE [ToUser] = @userId AND [HasBeenRead] = 0", Array(m_currentBloggerId))
		Dim retval(1)
		retval(0) = totalNum(0, 0) : retval(1) = newNum(0, 0) '返回一个一维数组，下标0：总悄悄话数目，下标1：未读悄悄话数目
		GetPMCount = retval
	End Function

	Public Function ReadPrivateMessage(pmId)
		Dim pm
		pm = m_dataOperator.ExecuteArray("SELECT * FROM T_PMs WHERE [PMID] = @pmId", Array(pmId))
		If Not IsArray(pm) Then
			Err.Raise vbObjectError + 1000, "nirvana: PrivateMessagesDB", "Specified private message does not exist!"
		End If
		m_currentPM.PMID = pm(0, 0)
		m_currentPM.FromName = pm(1, 0)
		m_currentPM.ToUser = pm(2, 0)
		m_currentPM.Title = pm(3, 0)
		m_currentPM.Content = pm(4, 0)
		m_currentPM.SendTime = pm(5, 0)
		m_currentPM.SenderEMail = pm(7, 0)
		m_currentPM.FromIP = pm(8, 0)

		m_dataOperator.ExecuteNonQuery "UPDATE T_PMs SET [HasBeenRead] = 1 WHERE [HasBeenRead] = 0 AND [PMID] = @pmId", Array(pmId)
		
		Set ReadPrivateMessage = m_currentPM
	End Function
End Class
%>
