﻿<%
'(P) 2006, C.K

'------------------------------------------------------------------------------
'Blog 帖子标签（Tag）类
'需要事先包含 CommonFunctions.asp 和 DataOperator 类的定义
'------------------------------------------------------------------------------

'结构太简单，就不要实体类了吧
Class TagsDB
	Private m_connString
	Private m_dataOperator
	Private m_currentBloggerId

	Private Sub Class_Initialize()
		m_currentBloggerId = 0
		Set m_dataOperator = New DataOperator
	End Sub

	Private Sub Class_Terminate()
		Set m_dataOperator = Nothing
	End Sub

	Public Property Let DataConnectionString(connStr)
		m_connString = connStr
		m_dataOperator.OpenDatabase connStr
	End Property

	Public Property Let CurrentBloggerID(bloggerId)
		m_currentBloggerId = bloggerId
	End Property

	Public Sub AddTags(tagString, entryId)
		If "" = tagString Then Exit Sub
		Dim tags
		tags = Split(Trim(tagString), " ") 'Tag 用空格分隔
		Dim tagCount, i
		tagCount = UBound(tags)
		For i = 0 To tagCount
			AddTagToDataTable tags(i), entryId
		Next
		'清除有关缓存
	End Sub
	Private Sub AddTagToDataTable(tagFace, entryId)
		m_dataOperator.ExecuteNonQuery "INSERT INTO T_Tags ([TagFace], [EntryID], [BloggerID]) VALUES (@tagFace, @entryId, @bloggerId)", Array(tagFace, entryId, m_currentBloggerId)
	End Sub

	Public Sub UpdateTags(tagString, entryId)
		'采取先删后加的方法？
		m_dataOperator.ExecuteNonQuery "DELETE FROM T_Tags WHERE [EntryID] = @entryId", Array(entryId)
		AddTags tagString, entryId
		'清除有关缓存
	End Sub

	'获取当前用户/所有用户的 tags 列表
	'参数 True：所有用户的；参数 False：当前用户的
	Public Function GetTagList(ofAll)
		Dim sql
		If Not ofAll Then
'			sql = "SELECT COUNT([EntryID]) AS EntryCount, [TagFace], 'BloggerID' FROM T_Tags WHERE [BloggerID] = @bloggerId AND [EntryID] NOT IN (SELECT [BID] FROM T_Blogs WHERE [BelongTo] = @bloggerId AND [State] = 0 OR [State] = 2) GROUP BY [TagFace] ORDER BY [TagFace]"
			sql = "SELECT COUNT([EntryID]) AS EntryCount, [TagFace], 'BloggerID' FROM T_Tags WHERE [BloggerID] = @bloggerId AND [EntryID] IN (SELECT [BID] FROM T_Blogs WHERE [BelongTo] = @bloggerId AND [State] = 1) GROUP BY [TagFace] ORDER BY [TagFace]"
		Else
'			sql = "SELECT COUNT([EntryID]) AS EntryCount, [TagFace] FROM T_Tags WHERE [EntryID] NOT IN (SELECT [BID] FROM T_Blogs WHERE [State] = 0 OR [State] = 2) AND [BloggerID] NOT IN (SELECT [UID] FROM T_Bloggers WHERE [Show] = False) GROUP BY [TagFace] ORDER BY [TagFace]"
			sql = "SELECT COUNT([EntryID]) AS EntryCount, [TagFace] FROM T_Tags WHERE [EntryID] IN (SELECT [BID] FROM T_Blogs WHERE [State] = 1) AND [BloggerID] IN (SELECT [UID] FROM T_Bloggers WHERE [Show] = True) GROUP BY [TagFace] ORDER BY [TagFace]"
		End If
		Dim rv
		If Not ofAll Then
			rv = m_dataOperator.ExecuteArray(sql, Array(m_currentBloggerId))
		Else
			rv = m_dataOperator.ExecuteArray(sql, Null)
		End If
		GetTagList = rv
	End Function

	'将 tags 集合生成云图（string）
	'urlPart 的形式为相对路径，例如：Tags.asp?ID=1&amp;Tag=
	Private Function MaxTagValue(tagArray)
		Dim max, tagCount, i
		tagCount = UBound(tagArray, 2)
		max = tagArray(0, 0)
		For i = 0 To tagCount
			If tagArray(0, i) >= max Then
				max = tagArray(0, i)
			End If
		Next
		MaxTagValue = max
	End Function
	Private Function MinTagValue(tagArray)
		Dim min, tagCount, i
		tagCount = UBound(tagArray, 2)
		min = tagArray(0, 0)
		For i = 0 To tagCount
			If tagArray(0, i) <= min Then
				min = tagArray(0, i)
			End If
		Next
		MinTagValue = min
	End Function
'	Public Function BuildTagCloud(tagArray, urlPart)
'		Dim ret
'		If IsNull(tagArray) Then
'			ret = ""
'		Else
'			Const BASE_SIZE = 12
'			Dim tagCount, sz, max, min, delta, total, tresholds(), nob
'			nob = 8
'			ReDim tresholds(nob - 1)
'			total = 0
'			max = MaxTagValue(tagArray) : min = MinTagValue(tagArray)
'			delta = (max - min) / nob
'			tagCount = UBound(tagArray, 2)
'
'			Dim r
'			For r = 0 To tagCount
'				total = total + tagArray(0, r)
'			Next
'
'			Dim i
'			For i = 0 To nob - 1
'				tresholds(i) = Round(min + i * delta)
'			Next
'
'			Dim s, k, fs_set
'			For s = 0 To tagCount
'				fs_set = False
'				For k = 0 To nob - 1
'					If Not fs_set Then
'						If tagArray(0, s) <= tresholds(k) Then
'							sz = BASE_SIZE + k * 2
'							fs_set = True
'						End If
'					End If
'				Next
'				If Not fs_set Then
'					sz = BASE_SIZE + (nob + 1) * 2
'				End If
'				ret = ret & " <a href='" & urlPart & Server.URLEncode(CStr(tagArray(1, s))) & "'><span style='font-size:" & CStr(sz) & "px;'>" & Server.HTMLEncode(CStr(tagArray(1, s))) & "</span></a> "
'			Next
'			If IsArray(tresholds) Then Erase tresholds
'		End If
'		BuildTagCloud = ret
'	End Function

	Private Function Log10(x)
		Log10 = Log(x) / Log(10)
	End Function

	Public Function BuildTagCloud(tagArray, urlPart)
		Dim ret
		If IsNull(tagArray) Then
			ret = ""
		Else
			Const MAX_LEVEL = 10
			Const MIN_LEVEL = 1

			Dim tagCount, max, min, lv
			max = MaxTagValue(tagArray) : min = MinTagValue(tagArray)
			tagCount = UBound(tagArray, 2)

			Dim s
			For s = 0 To tagCount
				If max > min Then
					lv = Log10(tagArray(0, s)) / (Log10(max) - Log10(min)) * (MAX_LEVEL - MIN_LEVEL) + MIN_LEVEL
				Else
					lv = 1 '……
				End If
				ret = ret & " <a href='" & urlPart & Server.URLEncode(CStr(tagArray(1, s))) & "'><span class='tagl" & CStr(Round(lv)) & "'>" & Server.HTMLEncode(CStr(tagArray(1, s))) & "</span></a> "
			Next
		End If
		BuildTagCloud = ret
	End Function

	'获取当前用户/全部用户满足某种 tag 组合的文章的列表。只选择公开网志
	Public Function GetEntriesByTag(tagQuery, ofAll)
		Dim rv, sql
		sql = BuildSQL(tagQuery, ofAll)
		If Not ofAll Then
			rv = m_dataOperator.ExecuteArray(sql, Array(m_currentBloggerId))
		Else
			rv = m_dataOperator.ExecuteArray(sql, Null)
		End If
		GetEntriesByTag = rv
	End Function

	'根据 tag 的组合生成 SQL 查询语句
	'现有 tag 组合：tag1+tag2：与；tag1|tag2：或。
	'暂时不支持 +| 的混合 -_-
	Private Function BuildSQL(query, ofAll)
		Dim rv, ands, ors, tagFacesCommaSep, tagCount, ofBlogger
		If Not ofAll Then
			ofBlogger = "AND [BloggerID] = @bloggerId"
		Else
			ofBlogger = ""
		End If
		If InStr(query, "|") > 0 Then '或
			ors = Split(query, "|")
			Dim cntOrs
			cntOrs = UBound(ors)
			Dim i
			For i = 0 To cntOrs
				tagFacesCommaSep = tagFacesCommaSep & "'" & Replace(ors(i), "'", "''") & "'"
				If i < cntOrs Then
					tagFacesCommaSep = tagFacesCommaSep & ", "
				End If
			Next
			rv = "SELECT [BID], [PostTime], [Title], [Expression], LEFT([Content], 101) AS Content1, [State], [BelongTo], 'EditLink', [Tags] FROM T_Blogs WHERE [BID] IN (SELECT [EntryID] FROM T_Tags WHERE [TagFace] IN (" & tagFacesCommaSep & ") " & ofBlogger & " GROUP BY [EntryID]) AND [State] = 1 ORDER BY [PostTime] DESC, [BID] DESC"
		ElseIf InStr(query, "+") > 0 Then '与
			ands = Split(query, "+")
			Dim cntAnds
			cntAnds = UBound(ands)
			tagCount = cntAnds + 1
			Dim j
			For j = 0 To cntAnds
				tagFacesCommaSep = tagFacesCommaSep & "'" & Replace(ands(j), "'", "''") & "'"
				If j < cntAnds Then
					tagFacesCommaSep = tagFacesCommaSep & ", "
				End If
			Next
			rv = "SELECT [BID], [PostTime], [Title], [Expression], LEFT([Content], 101) AS Content1, [State], [BelongTo], 'EditLink', [Tags] FROM T_Blogs WHERE [BID] IN (SELECT [EntryID] FROM T_Tags WHERE [TagFace] IN (" & tagFacesCommaSep & ") " & ofBlogger & " GROUP BY [EntryID] HAVING COUNT([EntryID]) = " & tagCount & ") AND [State] = 1 ORDER BY [PostTime] DESC, [BID] DESC"
		Else '查询单个 Tag
			rv = "SELECT [BID], [PostTime], [Title], [Expression], LEFT([Content], 101) AS Content1, [State], [BelongTo], 'EditLink', [Tags] FROM T_Blogs WHERE [BID] IN (SELECT [EntryID] FROM T_Tags WHERE [TagFace] = '" & Replace(query, "'", "''") & "' " & ofBlogger & " GROUP BY [EntryID]) AND [State] = 1 ORDER BY [PostTime] DESC, [BID] DESC"
		End If
		BuildSQL = rv
	End Function

	Public Function GetLatestEntriesByTag4Portal(tagQuery, num)
		Dim rv, sql
		If InStr(tagQuery, " ") > 0 Then '与：URL 里写 tag1+tag2+...
			Dim ands
			ands = Split(tagQuery, " ")
			Dim cntAnds, tagCount
			cntAnds = UBound(ands)
			tagCount = cntAnds + 1
			Dim commaSep, j
			For j = 0 To cntAnds
				commaSep = commaSep & "'" & Replace(ands(j), "'", "''") & "'"
				If j < cntAnds Then
					commaSep = commaSep & ", "
				End If
			Next
			sql = "SELECT TOP " & CStr(num) & " [BID], [BelongTo], [PostTime], [Title], [AuthorName], [Expression], [Content], [Tags], [CommentNum] FROM T_Blogs WHERE [BID] IN (SELECT [EntryID] FROM T_Tags WHERE [TagFace] IN (" & commaSep & ") GROUP BY [EntryID] HAVING COUNT([EntryID]) = " & tagCount & ") AND [State] = 1 AND [BelongTo] IN (SELECT [UID] FROM T_Bloggers WHERE [Show] = True) ORDER BY [PostTime] DESC, [BID] DESC"
		Else '单个 tag
			sql = "SELECT TOP " & CStr(num) & " [BID], [BelongTo], [PostTime], [Title], [AuthorName], [Expression], [Content], [Tags], [CommentNum] FROM T_Blogs WHERE [BID] IN (SELECT [EntryID] FROM T_Tags WHERE [TagFace] = '" & Replace(tagQuery, "'", "''") & "' GROUP BY [EntryID]) AND [State] = 1 AND [BelongTo] IN (SELECT [UID] FROM T_Bloggers WHERE [Show] = True) ORDER BY [PostTime] DESC, [BID] DESC"
		End If
		rv = m_dataOperator.ExecuteArray(sql, Null)
		GetLatestEntriesByTag4Portal = rv
	End Function
End Class
%>
