﻿// Client JavaScripts used by nirvana 0.6.0312

// Get element set by CSS selector
// Copied from the source code of Nifty Corners: http://pro.html.it/esempio/nifty/
function getElementsBySelector(selector)
{
	var i;
	var s = [];
	var selid = "";
	var selclass = "";
	var tag = selector;
	var objlist = [];
	if(selector.indexOf(" ") > 0) { // descendant selector like "tag#id tag"
		s = selector.split(" ");
		var fs = s[0].split("#");
		if(fs.length == 1) return objlist;
		return document.getElementById(fs[1]).getElementsByTagName(s[1]);
	}
	if(selector.indexOf("#") > 0) { // id selector like "tag#id"
		s = selector.split("#");
		tag = s[0];
		selid = s[1];
	}
	if(selid != "") {
		objlist.push(document.getElementById(selid));
		return objlist;
	}
	if(selector.indexOf(".") > 0) { // class selector like "tag.class"
		s = selector.split(".");
		tag = s[0];
		selclass = s[1];
	}
	var v = document.getElementsByTagName(tag); // tag selector like "tag"
	if(selclass == "") return v;
	for(i = 0; i < v.length; i++) {
		if(v[i].className == selclass) objlist.push(v[i]);
	}
	return objlist;
}

// 自动缩小图片
function ResizeImages()
{
	var limitedWidth = 640; // 这个 skin 所规定的最宽图片尺寸
	var imgs = getElementsBySelector("img.ubbLimitedWidth");
	if(imgs.length >= 1) {
		for(var i = 0; i < imgs.length; i++) {
			if(imgs[i].width > limitedWidth) {
				imgs[i].width = limitedWidth;
				imgs[i].alt = "点击查看原始尺寸的图片";
				imgs[i].style.cursor = "hand";
				imgs[i].onclick = function() {
					window.open(this.src);
				}
			}
		}
	}
}

// CSS styles switch
function setActiveStyleSheet(title)
{
	var i, a, main;
	if(title) {
		for(i = 0; (a = document.getElementsByTagName('link')[i]); i++) {
			if(a.getAttribute('rel').indexOf('style') != -1 && a.getAttribute('title')) {
				a.disabled = true;
				if(a.getAttribute('title') == title)
					a.disabled = false;
			}
		}
	}
}

function getActiveStyleSheet()
{
	var i, a;
	for(i = 0; (a = document.getElementsByTagName('link')[i]); i++) {
		if(a.getAttribute('rel').indexOf('style') != -1 && a.getAttribute('title') && !a.disabled)
			return a.getAttribute('title');
	}
	return null;
}
