﻿<%@ CodePage="65001"%>
<% Option Explicit %>
<!-- #Include File="Components/ConfigInfo.asp" -->
<!-- #Include File="Components/CommonFunctions.asp" -->
<!-- #Include File="Helpers/SystemEnabled.asp" -->
<!-- #Include File="Components/CDataOperator.asp" -->
<!-- #Include File="Components/CEnDec.asp" -->
<!-- #Include File="Components/CBloggersDB.asp" -->
<%
'北京时间转换为 GMT 时间-------------------------------------------------------
Function CST2GMT(cstDateTime)
	If Not IsDate(cstDateTime) Then
		Err.Raise vbObjectError + 1000, "CST2GMT", "参数错误：cstDateTime"
	End If

	'Wed, 31 Dec 2003 06:45:00 GMT
	Dim gmtDateTime, gmtWeekDay, gmtDay, gmtMonth, gmtYear, gmtTime, retval
	gmtDateTime = DateAdd("h", -8, cstDateTime) '北京时间减8小时
	gmtWeekDay = GetWeekdayName(Weekday(gmtDateTime))
	gmtDay = Day(gmtDateTime)
	gmtMonth = GetMonthName(Month(gmtDateTime))
	gmtYear = Year(gmtDateTime)
	gmtTime = FormatDateTime(gmtDateTime, vbShortTime)

	retval = gmtWeekDay & ", " & gmtDay & " " & gmtMonth & " " & gmtYear & " " & gmtTime & ":00 GMT"
	CST2GMT = retval
End Function

Function GetWeekdayName(weekdayIn)
	Dim retval
	Select Case weekdayIn
		Case 1
			retval = "Sun"
		Case 2
			retval = "Mon"
		Case 3
			retval = "Tue"
		Case 4
			retval = "Wed"
		Case 5
			retval = "Thu"
		Case 6
			retval = "Fri"
		Case 7
			retval = "Sat"
		Case Else
			Err.Raise vbObjectError + 1000, "CST2GMT", "参数错误：weekdayIn"
	End Select

	GetWeekdayName = retval
End Function

Function GetMonthName(monthIn)
	Dim retval
	Select Case monthIn
		Case 1
			retval = "Jan"
		Case 2
			retval = "Feb"
		Case 3
			retval = "Mar"
		Case 4
			retval = "Apr"
		Case 5
			retval = "May"
		Case 6
			retval = "Jun"
		Case 7
			retval = "Jul"
		Case 8
			retval = "Aug"
		Case 9
			retval = "Sep"
		Case 10
			retval = "Oct"
		Case 11
			retval = "Nov"
		Case 12
			retval = "Dec"
		Case Else
			Err.Raise vbObjectError + 1000, "CST2GMT", "参数错误：weekdayIn"
	End Select

	GetMonthName = retval
End Function
'------------------------------------------------------------------------------

Dim g_retVal
g_retVal = "<?xml version=""1.0"" encoding=""utf-8""?>"

Dim hasError
hasError = False

'获取并验证参数----------------------------------------------------------------
Dim bloggerId
bloggerId = Request.QueryString("ID")
If "" = bloggerId Then hasError = True
If Not IsNumeric(bloggerId) Then hasError = True
bloggerId = CLng(bloggerId)

Dim cateId
cateId = Request.QueryString("CateID")
If "" <> cateId Then
	If Not IsNumeric(cateId) Then hasError = True
	cateId = CLng(cateId)
End If
'------------------------------------------------------------------------------
%>
<!-- #Include File="Components/CommonCodes.asp" -->
<%
If hasError Then
	g_retVal = g_retVal & "<Msg>发生错误！</Msg>"
Else
	Dim cateTitle, cateDesc
	If cateId <> "" Then
		Dim arrCateInfo
		arrCateInfo = oBloggers.GetBlogCategoryNameDescByID(cateId, bloggerId)
		If Not IsNull(arrCateInfo) Then
			cateTitle = CStr(arrCateInfo(0, 0))
			cateDesc = CStr(arrCateInfo(1, 0))
		Else
			cateTitle = "未分类"
			cateDesc = ""
		End If
	End If

	'生成 RSS 2.0 的 XML 字符串
	g_retVal = g_retVal & "<rss version=""2.0""><channel>"
	If "" = cateId Then
		g_retVal = g_retVal & "<title>" & Server.HTMLEncode(arrThisBlogBasicInfo(1)) & "</title>" 'title - Blog
	Else
		g_retVal = g_retVal & "<title>" & Server.HTMLEncode(arrThisBlogBasicInfo(1)) & " - " & Server.HTMLEncode(cateTitle) & "</title>" 'title - 某分类
	End If
	g_retVal = g_retVal & "<link>http://" & Request.ServerVariables("HTTP_HOST") & CF_GetCurrentVirtualDir() & "/Blog.asp?ID=" & CStr(bloggerId) & "</link>" 'link
	If "" = cateId Then
		g_retVal = g_retVal & "<description>" & Server.HTMLEncode("" & arrThisBlogBasicInfo(2)) & "</description>" 'description - Blog
	Else
		g_retVal = g_retVal & "<description>" & Server.HTMLEncode("" & cateDesc) & "</description>" 'description - 某分类
	End If
	g_retVal = g_retVal & "<language>zh-CN</language>" 'language

	Dim blogInfo
	If "" = cateId Then
		blogInfo = oBloggers.GetTopEntries(bloggerId, 25) '最多取 25 篇
	Else
		blogInfo = oBloggers.GetBlogListByCategory4Feed(bloggerId, cateId, 25)
	End If
	If Not IsNull(blogInfo) Then
		Dim r
		Dim blogInfoCount
		blogInfoCount = UBound(blogInfo, 2)
		For r = 0 To blogInfoCount
			g_retVal = g_retVal & "<item>"
			If 1 = blogInfo(8, r) Then '公开 blog
				g_retVal = g_retVal & "<title>" & Server.HTMLEncode(blogInfo(4, r)) & "</title>" 'title
				g_retVal = g_retVal & "<link>http://" & Request.ServerVariables("HTTP_HOST") & CF_GetCurrentVirtualDir() & "/Read.asp?ID=" & CStr(bloggerId) & "&amp;BID=" & CStr(blogInfo(0, r)) & "</link>" 'link
				g_retVal = g_retVal & "<pubDate>" & CST2GMT(blogInfo(2, r)) & "</pubDate>" 'pubDate
				g_retVal = g_retVal & "<author>" & Server.HTMLEncode(arrThisBlogBasicInfo(0)) & "</author>" 'author
				g_retVal = g_retVal & "<description>" & Server.HTMLEncode(CF_UBBCode(blogInfo(6, r), False)) & "</description>" 'description
				g_retVal = g_retVal & "<comments>http://" & Request.ServerVariables("HTTP_HOST") & CF_GetCurrentVirtualDir() & "/Read.asp?ID=" & CStr(bloggerId) & "&amp;BID=" & CStr(blogInfo(0, r)) & "#Feedback</comments>" 'comments
			Else
				g_retVal = g_retVal & "<title>保密网志</title>" 'title
				g_retVal = g_retVal & "<link>http://" & Request.ServerVariables("HTTP_HOST") & CF_GetCurrentVirtualDir() & "/Blog.asp?ID=" & CStr(bloggerId) & "</link>" 'link
				g_retVal = g_retVal & "<pubDate>" & CST2GMT(blogInfo(2, r)) & "</pubDate>" 'pubDate
				g_retVal = g_retVal & "<author>" & Server.HTMLEncode(arrThisBlogBasicInfo(0)) & "</author>" 'author
				g_retVal = g_retVal & "<description>本条网志内容保密，请访问相应页面，凭借好友密码查看。</description>" 'description
			End If
			g_retVal = g_retVal & "</item>"
		Next
	End If

	g_retVal = g_retVal & "</channel></rss>"
	Set oBloggers = Nothing
End If

Session.CodePage = 65001
Response.ContentType = "text/xml; charset=utf-8" '输出 XML 内容
Response.Write g_retVal
%>
