﻿// nirvana 后台管理相关脚本

// 按照 CSS 选择符获取元素集合
// （摘自 Nifty Corners 的代码：http://pro.html.it/esempio/nifty/）
function cf_GetElementsBySelector(selector)
{
	var i;
	var s = [];
	var selid = "";
	var selclass = "";
	var tag = selector;
	var objlist = [];
	if(selector.indexOf(" ") > 0) { // descendant selector like "tag#id tag"
		s = selector.split(" ");
		var fs = s[0].split("#");
		if(fs.length == 1) return objlist;
		return document.getElementById(fs[1]).getElementsByTagName(s[1]);
    }
	if(selector.indexOf("#") > 0) { // id selector like "tag#id"
		s = selector.split("#");
		tag = s[0];
		selid = s[1];
	}
	if(selid != "") {
		objlist.push(document.getElementById(selid));
		return objlist;
    }
	if(selector.indexOf(".") > 0) { // class selector like "tag.class"
		s = selector.split(".");
		tag = s[0];
		selclass = s[1];
	}
	var v = document.getElementsByTagName(tag); // tag selector like "tag"
	if(selclass == "")
		return v;
	for(i = 0; i < v.length; i++) {
		if(v[i].className == selclass) {
			objlist.push(v[i]);
		}
	}
	return objlist;
}

// 禁用按钮
function DisableButton(buttonId)
{
	var b = document.getElementById(buttonId);
	if(b != null)
		b.disabled = true;
}

// 文本框获取焦点
function SetFocus(textBoxId)
{
	var t = document.getElementById(textBoxId);
	if(t != null)
		t.focus();
}

// 编辑自定义分类结相关验证
function ValidFormCateAdd()
{
	var t = document.getElementById("txtCateNameAdd").value;
	if(t == "") {
		alert("分类名不能为空！");
		return false;
	}
	DisableButton("btnPostAdd");
	return true;
}

function ValidFormCateMod()
{
	var t = document.getElementById("txtCateNameMod").value;
	if(t == "") {
		alert("分类名不能为空！");
		return false;
	}
	DisableButton("btnPostMod");
	return true;
}

// 编辑友情链结相关验证
function ValidFormLinkAdd()
{
	var t = document.getElementById("txtLinkTitleAdd").value;
	var a = document.getElementById("txtLinkAddrAdd").value;
	if(t == "" || a == "") {
		alert("链结标题和地址都不能为空！");
		return false;
	}
	DisbaleButton("btnPostAdd");
	return true;
}

function ValidFormLinkMod()
{
	var t = document.getElementById("txtLinkTitleMod").value;
	var a = document.getElementById("txtLinkAddrMod").value;
	if(t == "" || a == "") {
		alert("链结标题和地址都不能为空！");
		return false;
	}
	DisableButton("btnPostMod");
	return true;
}

// 编辑网志相关
function ValidFormEditPost()
{
	var t = document.getElementById("txtTitle").value;
	var c = document.getElementById("txtContent").value;
	var a = document.getElementById("txtTags").value;
	if(t == "" || c == "") {
		alert("标题和内容不能为空！");
		return false;
	}
	if(a != "") {
		if(/[^\u4E00-\u9FA0a-zA-Z0-9._ ]/.test(a)) {
			alert("Tag 名中不能含有除中文、字母、数字、句点、空格和下划线之外的字符！");
			return false;
		}
		var hasSame = false;
		var aa = a.split(" ");
		for(var i = 0; i < aa.length; i++) {
			for(var j = i + 1; j < aa.length; j++) {
				if(aa[i] == aa[j]) {
					hasSame = true;
					break;
				}
			}
		}
		if(hasSame) {
			alert("Tag 中有重复字符，请修改！");
			return false;
		}
	}
	DisableButton("btnPost");
	return true;
}

// 修改 Blog 注册信息相关
function ValidFormModRegInfo()
{
	var p = document.getElementById("txtPassword").value;
	var rp = document.getElementById("txtConfirmPwd").value;
	var fp = document.getElementById("BlogFriendPwd").value;
	var t = document.getElementById("txtBlogTitle").value;
	var e = document.getElementById("txtEMail").value;
	// 必填项目
	if(p == "" || rp == "" || t == "" || fp == "") {
		alert("带 * 的项目请完整填写！");
		return false;
	}
	// 密码确认
	if(p != rp) {
		alert("两次密码输入不一致！");
		return false;
	}
	// E-mail 的格式
	if(e != "") {
		if(!/(\S)+[@]{1}(\S)+[.]{1}(\S)+/.test(e)) {
			alert("请输入格式正确的 e-mail 地址！");
			return false;
		}
	}
	
	DisableButton("btnPost");
	return true;
}

// 皮肤预览
function ShowSkinPreview()
{
	var skinFileName = "Preview.jpg";
	var prvImage = document.getElementById("imgPreview");
	var skinSel = document.getElementById("selBlogSkin");
	var skinPath = "../Skins/" + skinSel.value + "/";
	prvImage.src = skinPath + skinFileName;

	var skinDescDiv = document.getElementById("skinDescr");
	var descText = skinSel.options[skinSel.selectedIndex].title;
	skinDescDiv.innerHTML = descText;
}

// 登录
function ValidFormLogin()
{
	var u = document.getElementById("txtUserName").value;
	var p = document.getElementById("txtPassword").value;
	if(u == "" || p == "") {
		alert("请输入用户名/密码！");
		return false;
	}
	DisableButton("btnLogin");
	return true;
}

// 插入表情图片相关
var showEmoPixListFlag = false;

function toggleEmoPixList()
{
	var listDiv = document.getElementById("emoPixList");
	if(showEmoPixListFlag) {
		listDiv.style.display = "none";
		showEmoPixListFlag = false;
	} else {
		listDiv.style.display = "block";
		showEmoPixListFlag = true;
	}
}
function doShowEmoPixList()
{
	showEmoPixListFlag = false;
	toggleEmoPixList();
}
function doHideEmoPixList()
{
	showEmoPixListFlag = true;
	toggleEmoPixList();
}

function insertEmotion(emoCode)
{
	edInsertContent(edCanvas, emoCode); // 调用 UBB 编辑器的插入内容的代码
	doHideEmoPixList();
}
